
const db = require('../models');
const FileDBApi = require('./file');
const crypto = require('crypto');
const Utils = require('../utils');



const Sequelize = db.Sequelize;
const Op = Sequelize.Op;

module.exports = class Test_result_pointsDBApi {
    

    
    static async create(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const test_result_points = await db.test_result_points.create(
            {
                id: data.id || undefined,
        
        measured_at: data.measured_at
        ||
        null
            ,
            
        parameter_name: data.parameter_name
        ||
        null
            ,
            
        value: data.value
        ||
        null
            ,
            
        unit: data.unit
        ||
        null
            ,
            
        confidence_level: data.confidence_level
        ||
        null
            ,
            
        notes: data.notes
        ||
        null
            ,
            
            importHash: data.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
    },
        { transaction },
    );

        
        await test_result_points.setMetallurgical_test( data.metallurgical_test || null, {
            transaction,
        });
        
        await test_result_points.setOrganizations( data.organizations || null, {
            transaction,
        });
        

        

        

        return test_result_points;
    }
    

    static async bulkImport(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        // Prepare data - wrapping individual data transformations in a map() method
        const test_result_pointsData = data.map((item, index) => ({
                id: item.id || undefined,
                
                measured_at: item.measured_at
            ||
            null
            ,
            
                parameter_name: item.parameter_name
            ||
            null
            ,
            
                value: item.value
            ||
            null
            ,
            
                unit: item.unit
            ||
            null
            ,
            
                confidence_level: item.confidence_level
            ||
            null
            ,
            
                notes: item.notes
            ||
            null
            ,
            
            importHash: item.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
            createdAt: new Date(Date.now() + index * 1000),
    }));

        // Bulk create items
        const test_result_points = await db.test_result_points.bulkCreate(test_result_pointsData, { transaction });

        // For each item created, replace relation files
        

        return test_result_points;
    }

    static async update(id, data,  options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;
        const globalAccess = currentUser.app_role?.globalAccess;

        const test_result_points = await db.test_result_points.findByPk(id, {}, {transaction});


        

        const updatePayload = {};
        
        if (data.measured_at !== undefined) updatePayload.measured_at = data.measured_at;
        
        
        if (data.parameter_name !== undefined) updatePayload.parameter_name = data.parameter_name;
        
        
        if (data.value !== undefined) updatePayload.value = data.value;
        
        
        if (data.unit !== undefined) updatePayload.unit = data.unit;
        
        
        if (data.confidence_level !== undefined) updatePayload.confidence_level = data.confidence_level;
        
        
        if (data.notes !== undefined) updatePayload.notes = data.notes;
        
        
        updatePayload.updatedById = currentUser.id;

        await test_result_points.update(updatePayload, {transaction});

        
        
        if (data.metallurgical_test !== undefined) {
            await test_result_points.setMetallurgical_test(
              
              data.metallurgical_test,
              
              { transaction }
            );
        }
        
        if (data.organizations !== undefined) {
            await test_result_points.setOrganizations(
              
              data.organizations,
              
              { transaction }
            );
        }
        

        
        

        

        return test_result_points;
    }

    static async deleteByIds(ids, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const test_result_points = await db.test_result_points.findAll({
            where: {
                id: {
                    [Op.in]: ids,
                },
            },
            transaction,
        });

        await db.sequelize.transaction(async (transaction) => {
            for (const record of test_result_points) {
                await record.update(
                    {deletedBy: currentUser.id},
                    {transaction}
                );
            }
            for (const record of test_result_points) {
                await record.destroy({transaction});
            }
        });


        return test_result_points;
    }

    static async remove(id, options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;

        const test_result_points = await db.test_result_points.findByPk(id, options);

        await test_result_points.update({
            deletedBy: currentUser.id
        }, {
            transaction,
        });

        await test_result_points.destroy({
            transaction
        });

        return test_result_points;
    }

    static async findBy(where, options) {
        const transaction = (options && options.transaction) || undefined;

        const test_result_points = await db.test_result_points.findOne(
            { where },
            { transaction },
        );

        if (!test_result_points) {
            return test_result_points;
        }

        const output = test_result_points.get({plain: true});

        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        output.metallurgical_test = await test_result_points.getMetallurgical_test({
            transaction
        });
        
        
        output.organizations = await test_result_points.getOrganizations({
            transaction
        });
        
        

        return output;
    }

    static async findAll(
          filter,
           globalAccess,  options
        ) {
        const limit = filter.limit || 0;
        let offset = 0;
        let where = {};
        const currentPage = +filter.page;

        
        const user = (options && options.currentUser) || null;
        const userOrganizations = (user && user.organizations?.id) || null;
        

        
        if (userOrganizations) {
            if (options?.currentUser?.organizationsId) {
                where.organizationsId = options.currentUser.organizationsId;
            }
        }
        

        offset = currentPage * limit;

        const orderBy = null;

    const transaction = (options && options.transaction) || undefined;

    let include = [

      {
        model: db.metallurgical_tests,
        as: 'metallurgical_test',
        
        where: filter.metallurgical_test ? {
          [Op.or]: [
            { id: { [Op.in]: filter.metallurgical_test.split('|').map(term => Utils.uuid(term)) } },
            {
              lab_reference: {
                [Op.or]: filter.metallurgical_test.split('|').map(term => ({ [Op.iLike]: `%${term}%` }))
              }
            },
          ]
        } : {},
        
      },

      {
        model: db.organizations,
        as: 'organizations',
        
      },



    ];

        if (filter) {
            if (filter.id) {
                where = {
                    ...where,
                    ['id']: Utils.uuid(filter.id),
                };
            }

            
            if (filter.parameter_name) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'test_result_points',
                        'parameter_name',
                        filter.parameter_name,
                    ),
                };
            }
            
            if (filter.unit) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'test_result_points',
                        'unit',
                        filter.unit,
                    ),
                };
            }
            
            if (filter.notes) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'test_result_points',
                        'notes',
                        filter.notes,
                    ),
                };
            }
            

            
            

            
            if (filter.measured_atRange) {
                const [start, end] = filter.measured_atRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                    measured_at: {
                    ...where.measured_at,
                            [Op.gte]: start,
                    },
                };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                    measured_at: {
                    ...where.measured_at,
                            [Op.lte]: end,
                    },
                };
                }
            }
            
            if (filter.valueRange) {
                const [start, end] = filter.valueRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                    value: {
                    ...where.value,
                            [Op.gte]: start,
                    },
                };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                    value: {
                    ...where.value,
                            [Op.lte]: end,
                    },
                };
                }
            }
            
            if (filter.confidence_levelRange) {
                const [start, end] = filter.confidence_levelRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                    confidence_level: {
                    ...where.confidence_level,
                            [Op.gte]: start,
                    },
                };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                    confidence_level: {
                    ...where.confidence_level,
                            [Op.lte]: end,
                    },
                };
                }
            }
            

            if (filter.active !== undefined) {
                where = {
                    ...where,
                    active: filter.active === true || filter.active === 'true'
                };
            }

            


      

      
      if (filter.organizations) {
        const listItems = filter.organizations.split('|').map(item => {
          return  Utils.uuid(item)
        });

        where = {
          ...where,
          organizationsId: {[Op.or]: listItems}
        };
      }
      



            if (filter.createdAtRange) {
                const [start, end] = filter.createdAtRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.gte]: start,
                        },
                    };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.lte]: end,
                        },
                    };
                }
            }
        }
        

        
        if (globalAccess) {
            delete where.organizationsId;
        }
        

        const queryOptions = {
            where,
            include,
            distinct: true,
            order: filter.field && filter.sort
                ? [[filter.field, filter.sort]]
                : [['createdAt', 'desc']],
            transaction: options?.transaction,
            logging: console.log
        };

        if (!options?.countOnly) {
            queryOptions.limit = limit ? Number(limit) : undefined;
            queryOptions.offset = offset ? Number(offset) : undefined;
        }

        try {
            const { rows, count } = await db.test_result_points.findAndCountAll(queryOptions);

            return {
                rows: options?.countOnly ? [] : rows,
                count: count
            };
        } catch (error) {
            console.error('Error executing query:', error);
            throw error;
        }
    }

    static async findAllAutocomplete(query, limit, offset,  globalAccess, organizationId,) {
        let where = {};
        
        
        if (!globalAccess && organizationId) {
            where.organizationId = organizationId;
        }
        

        if (query) {
            where = {
                [Op.or]: [
                    { ['id']: Utils.uuid(query) },
                    Utils.ilike(
                        'test_result_points',
                        'parameter_name',
                        query,
                    ),
                ],
            };
        }

        const records = await db.test_result_points.findAll({
            attributes: [ 'id', 'parameter_name' ],
            where,
            limit: limit ? Number(limit) : undefined,
            offset: offset ? Number(offset) : undefined,
            orderBy: [['parameter_name', 'ASC']],
        });

        return records.map((record) => ({
            id: record.id,
            label: record.parameter_name,
        }));
    }

    
};

